VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Expression"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Const MyName As String = "ExpressionClass"

'      
'(c)  , 2003

', 04.07.2003 01:10
',  ...

Private Const Plus As String = "+"
Private Const Minus As String = "-"

Private Const Mult As String = "*"
Private Const Div As String = "/"
Private Const DivInt As String = "\"

Private Const Power As String = "^"

Private Const LeftPar As String = "("
Private Const RightPar As String = ")"

Public Enum ExprErrors
  exprNoError
  exprErrorParentheses
  exprErrorInvalidExpression
  exprErrorUnknownFunction
End Enum

Public Function Value(ByVal E As String) As Double
Attribute Value.VB_UserMemId = 0
  Dim i As Long
  Dim tmpLng As Long, tmpStr As String
  
  E = LCase$(Replace(E, " ", vbNullString))
  E = Replace(E, RightPar + LeftPar, RightPar + Mult + LeftPar)
  
  ' ,    .
  '  .   -  1,
  ' -  1.     >=0,    =0
  
  For i = 1 To Len(E)
    tmpStr = Mid$(E, i, 1)
    If tmpStr = LeftPar Then
      tmpLng = tmpLng + 1
    ElseIf tmpStr = RightPar Then
      tmpLng = tmpLng - 1
    End If
    If tmpLng < 0 Then Err.Raise exprErrorParentheses, MyName, "Parentheses do not match"
  Next
  If tmpLng Then Err.Raise exprErrorParentheses, MyName, "Parentheses do not match"
  
  Value = CalcSummand(E)
End Function

Private Function CalcSummand(S As String) As Double
  Dim i As Long, minPrior As Byte, minPriorPos As Long
  Dim NestingLevel As Long, tmpStr As String
  
  '   ?
  If Len(S) = 0 Then Exit Function '  
  
  ',       
  Do While LISP(S)
  Loop
  
  '         
  minPrior = 2
  For i = 1 To Len(S)
    Select Case Mid$(S, i, 1)
    Case LeftPar
      NestingLevel = NestingLevel + 1
    Case RightPar
      NestingLevel = NestingLevel - 1
    Case Plus, Minus
      If NestingLevel = 0 Then
        minPrior = 0
        minPriorPos = i
        Exit For
      End If
    Case Mult, Div, DivInt
      If NestingLevel = 0 Then
        If minPrior = 2 Then
          minPrior = 1
          minPriorPos = i
        Else
          If minPriorPos = 0 Then minPriorPos = i
        End If
      End If
    Case Power
      If NestingLevel = 0 Then
        If minPrior = 2 And minPriorPos = 0 Then minPriorPos = i
      End If
    End Select
  Next
  
  If minPriorPos = 0 Then
    ' ,       .
    ',   , ,     ,
    '   .
    CalcSummand = IsFunction(S)
    If CalcSummand >= 0 Then
      Exit Function '  ,   
    Else
      '  .   , ..    IsFunction
      ' minPriorPos       .
      '     .    
      ' VB,  -...
      minPriorPos = InStr(S, LeftPar)
      tmpStr = Left$(S, minPriorPos - 1)
      '    CallByName  ?
      '   ...
      Select Case tmpStr
      Case "abs"
        CalcSummand = Abs(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case "atn"
        CalcSummand = Atn(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case "cos"
        CalcSummand = Cos(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case "exp"
        CalcSummand = Exp(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case "log"
        CalcSummand = Log(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case "sgn"
        CalcSummand = Sgn(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case "sin"
        CalcSummand = Sin(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case "sqr"
        CalcSummand = Sqr(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case "tan"
        CalcSummand = Tan(CalcSummand(Mid$(S, minPriorPos + 1, Len(S) - minPriorPos - 1)))
      Case Else
        Err.Raise exprErrorUnknownFunction, MyName, "Unknown function " + UCase$(tmpStr) + " detected"
      End Select
    End If
  Else
    '  . ...
    If minPriorPos = 1 Then '  -expr
      tmpStr = Left$(S, 1)
      If tmpStr = Plus Or tmpStr = Minus Then
        CalcSummand = IIf(tmpStr = Minus, -1, 1) * CalcSummand(Mid$(S, 2))
      Else
        Err.Raise exprErrorInvalidExpression, MyName, "Expression is invalid"
      End If
    Else                    ' a +-*/\^ b
      Select Case Mid$(S, minPriorPos, 1)
      Case Plus
        CalcSummand = CalcSummand(Left$(S, minPriorPos - 1)) + CalcSummand(Right$(S, Len(S) - minPriorPos))
      Case Minus
        CalcSummand = CalcSummand(Left$(S, minPriorPos - 1)) - CalcSummand(Right$(S, Len(S) - minPriorPos))
      Case Mult
        CalcSummand = CalcSummand(Left$(S, minPriorPos - 1)) * CalcSummand(Right$(S, Len(S) - minPriorPos))
      Case Div
        '    VB    ...
        CalcSummand = CalcSummand(Left$(S, minPriorPos - 1)) / CalcSummand(Right$(S, Len(S) - minPriorPos))
      Case DivInt
        CalcSummand = CalcSummand(Left$(S, minPriorPos - 1)) \ CalcSummand(Right$(S, Len(S) - minPriorPos))
      Case Power
        CalcSummand = CalcSummand(Left$(S, minPriorPos - 1)) ^ CalcSummand(Right$(S, Len(S) - minPriorPos))
      Case Else
        ' ,     ...
        Err.Raise exprErrorInvalidExpression, MyName, "Expression is invalid"
      End Select
    End If
  End If
End Function

Private Function LISP(ByRef S As String) As Boolean
  Dim i As Long, tmp As Long
  
  'LISP = Lots of Idiot Silly Parentheses!
  '  LISP     ... :)
  
  '        ,
  '     ,    
  ' ,    .
  '   .
  
  If Left$(S, 1) = LeftPar And Right$(S, 1) = RightPar Then
    For i = 1 To Len(S)
      If Mid$(S, i, 1) = LeftPar Then
        tmp = tmp + 1
      ElseIf Mid$(S, i, 1) = RightPar Then
        tmp = tmp - 1
        If tmp = 0 And i <> Len(S) Then Exit Function
      End If
    Next
  Else
    Exit Function
  End If
  
  '  
  S = Mid$(S, 2, Len(S) - 2)
  LISP = True
End Function

Private Function IsFunction(F As String) As Double
  ' -        .
  '  !   " + "    ,
  '    
  Dim i As Long
  
  '    ,  
  '  ,   
  i = InStr(F, LeftPar)
  If i = 0 Then
    '  . , ?
    For i = 1 To Len(F)
      If InStr("0123456789.", Mid$(F, i, 1)) = 0 Then Exit For
    Next
    If i = Len(F) + 1 Then IsFunction = Val(F) Else Err.Raise exprErrorInvalidExpression, MyName, "Expression is invalid"
    '  ,    
    ' (-)(expression),     ,
    '      
    Exit Function
  End If
  
  ' ( ,  )  ,      .
  '       .   
  '  
  IsFunction = -1 ',  
End Function
